/*****************************************************************************/
/*                                                                           */
/* FILENAME                                                                  */
/* 	 main.c                                                                  */
/*                                                                           */
/* DESCRIPTION                                                               */
/*   TMS320C5515 USB Stick Application 20 Spectrum Analyser.                 */
/*   Take microphone input and send to headphones with ring modulation.      */
/*                                                                           */
/* REVISION                                                                  */
/*   Revision: 1.00	                                                         */
/*   Author  : Richard Sikora                                                */
/*---------------------------------------------------------------------------*/
/*                                                                           */
/* HISTORY                                                                   */
/*   Revision: 1.00                                                          */
/*   15th September 2010. Created from TMS320C5505 USB Stick code.           */
/*                                                                           */
/*****************************************************************************/
/*
 * Copyright (C) 2010 Texas Instruments Incorporated - http://www.ti.com/ 
 * 
 * 
 *  Redistribution and use in source and binary forms, with or without 
 *  modification, are permitted provided that the following conditions 
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the   
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
*/

#include "stdio.h"
#include "usbstk5515.h"
#include "usbstk5515_led.h"
#include "aic3204.h"
#include "PLL.h"
#include "oled.h"
#include "pushbuttons.h"
#include "stereo.h"
#include "dsplib.h"

Int16 left_input;
Int16 right_input;
Int16 left_output;
Int16 right_output;
Int16 mono_input;

#define SAMPLES_PER_SECOND 48000
#define GAIN_IN_dB 0

unsigned int Step = 0; 
unsigned int LastStep = 99;
 
/* ------------------------------------------------------------------------ *
 *                                                                          *
 *  main( )                                                                 *
 *                                                                          *
 * ------------------------------------------------------------------------ */
void main( void ) 
{
    /* Initialize BSL */
    USBSTK5515_init( );
	
	/* Initialize PLL */
	pll_frequency_setup(120);

    /* Initialise hardware interface and I2C for code */
    aic3204_hardware_init();
    
    /* Initialise the AIC3204 codec */
	aic3204_init(); 
	
	/* Turn off the 4 coloured LEDs */
	USBSTK5515_ULED_init();
	
	/* Initialise the OLED LCD display */
	oled_init();
	SAR_init();
	/* Flush display buffer */
    oled_display_message("                 ", "                   ");
    
	/* Setup sampling frequency and  gain for microphone */
    set_sampling_frequency_and_gain(SAMPLES_PER_SECOND, GAIN_IN_dB);

	oled_display_message("                 ", "                   ");
    oled_display_message("Cwiczenie 2      ", "Dodawanie mnozenie ");
    
    printf("\n\nLaboratorium CPS\n");
    printf("Dodawanie i mnożenie sygnałów modularne i nasyceniowe\n" );
    puts(" 1 - TalkThru");
    puts(" 2 - mnożenie przez 2 - modularne i nasyceniowe");
    puts(" 3 - modularne dodawanie i mnożenie kanałów");
    puts(" 4 - dodawanie kanałów modularne i nasyceniowe");
    puts(" 5 - mnożenie kanałów modularne i nasyceniowe");
	puts(" 6 - nasyceniowe mnożenie sygnału przez siebie");

      
	/* Default to XF LED off */
	asm(" bclr XF");
	
	rand16init();
    
 	for ( ;; )
 	{

     aic3204_codec_read(&left_input, &right_input); // Configured for one interrupt per two channels.
   
     mono_input = stereo_to_mono(left_input, right_input);
     
    // if (left_input <= -22760) printf("Jest\n");
     
     Step = pushbuttons_read(6);
         
	  if ( Step == 1 )
        {
         if ( Step != LastStep )
          {
           oled_display_message("L = L; bez zmiany ", "P = P; bez zmiany ");
           printf("1\n Na obu wyjściach sygnał wejściowy\n");
           LastStep = Step;
          }	
         left_output = left_input;      // Straight trough. No processing.
	     right_output = right_input;

	    } 
	    if ( Step == 2 )
        {
         if ( Step != LastStep )
          {
           oled_display_message("L = 2 x L         ", "P = SAT 2 x L     ");
           printf("2\nKanał lewy:  mnożenie razy 2 modularne \n");
           printf(  "Kanał prawy: mnożenie razy 2 nasyceniowe \n");
           LastStep = Step;
          }	
         left_output  = left_input << 1;      // Straight trough. No processing.
	     right_output = _sshl(left_input,1);

	    } 
	    
	  if ( Step == 3)
        {
         if ( Step != LastStep )
          {
           oled_display_message("L = L/2 + p/2;    ", "P = L x P; iloczyn");
           printf("3\nKanał lewy:  dodawanie kanałów modularne z dzieleniem przez 2\n");
           printf(  "Kanał prawy: mnożenie kanałów modularne \n");
           
           LastStep = Step;
          }	
         left_output = ((long)left_input + right_input) >> 1;      // Straight trough. No processing.
	     right_output = ((long)left_input * right_input) >> 15;

	    } 
      if ( Step == 4)
        {
         if ( Step != LastStep )
          {
           oled_display_message("L = L + P;        ", "P = SAT(L + P);    ");
           printf("4\nKanał lewy:  dodawanie kanałów modularne \n");
           printf(  "Kanał prawy: dodawanie kanałów nasyceniowe \n");
           LastStep = Step;
          }	
         left_output = left_input + right_input;      
	     right_output = _sadd(left_input, right_input);

	    } 
	     if ( Step == 5)
        {
         if ( Step != LastStep )
          {
           oled_display_message("P = L x P;         ", "P = SAT(L x P);       ");
           printf("5\nKanał lewy:  mnożenie kanałów modularne \n");
           printf(  "Kanał prawy: mnożenie kanałów nasyceniowe \n");
           LastStep = Step;
          }	
         left_output = ((long)left_input * right_input) >> 15;     // Straight trough. No processing.
         //left_output = left_input;
	     right_output = _smpy(left_input, right_input);

	    } 
	    if ( Step == 6)
        {
         if ( Step != LastStep )
          {
           oled_display_message("L = L;         ", "P = SAT(L x L);       ");
           printf("6\nKanał lewy:  wejście lewe \n");
           printf(  "Kanał prawy: wejście lewe * wejście lewe - mnożenie modularne \n");
           
           LastStep = Step;
          }	
         //left_output = ((long)left_input * right_input) >> 15;     // Straight trough. No processing.
         left_output = left_input;
	     //right_output = _smpy(left_input, left_input);
	     right_output = ((long)left_input * left_input) >> 15;

	    } 	    	  
	    
     aic3204_codec_write(left_output, right_output);

 	}

   /* Disable I2S and put codec into reset */ 
    aic3204_disable();

    printf( "\n***Program has Terminated***\n" );
    
    oled_display_message("PROGRAM HAS        ", "TERMINATED        ");
    
    SW_BREAKPOINT;
}

/* ------------------------------------------------------------------------ *
 *                                                                          *
 *  End of main.c                                                           *
 *                                                                          *
 * ------------------------------------------------------------------------ */
